# -*- coding: utf-8 -*-
# thanks to TheWiz Addon Installer....
# Thanks to Blazetamer, Eleazar Coding, Showgun, TheHighway, ....
import requests,shutil, json, sys, os, xbmcgui, time, xbmc, urllib, urllib2, re, zipfile ,xbmcaddon ,xbmcplugin, xbmcvfs
import addonsettings
from xml.dom import minidom


dialog       =  xbmcgui.Dialog()
dp           =  xbmcgui.DialogProgress()
Progress = xbmcgui.DialogProgress()
Config = xbmcaddon.Addon('plugin.program.senyorwizard')

ADDON_ID      = 'plugin.program.senyorwizard'
REAL_SETTINGS = xbmcaddon.Addon(id=ADDON_ID)
ADDON_ID      = REAL_SETTINGS.getAddonInfo('id')
ADDON_NAME    = REAL_SETTINGS.getAddonInfo('name')
ADDON_PATH    = (REAL_SETTINGS.getAddonInfo('path').decode('utf-8'))
ADDON_VERSION = REAL_SETTINGS.getAddonInfo('version')
ICON          = os.path.join(ADDON_PATH, 'icon.png')
FANART        = os.path.join(ADDON_PATH, 'fanart.jpg')

CONTENTS = ["unknown",
            "video",
            "audio",
            "image",	
            "executable"]
            
TYPES    = ["unknown",
            "xbmc.player.musicviz",
            "xbmc.pvrclient",
            "xbmc.gui.skin",
            "kodi.adsp",
            "kodi.inputstream",
            "kodi.peripheral",
            "xbmc.python.script",
            "xbmc.python.weather",
            "xbmc.subtitle.module",
            "xbmc.python.lyrics",
            "xbmc.metadata.scraper.albums",
            "xbmc.metadata.scraper.artists",
            "xbmc.metadata.scraper.movies",
            "xbmc.metadata.scraper.musicvideos",
            "xbmc.metadata.scraper.tvshows",
            "xbmc.ui.screensaver",
            "xbmc.python.pluginsource",
            "xbmc.addon.repository",
            "xbmc.webinterface",
            "xbmc.service",
            "xbmc.audioencoder",
            "kodi.context.item",
            "kodi.audiodecoder",
            "kodi.resource.images",
            "kodi.resource.language",
            "kodi.resource.uisounds",
            "xbmc.addon.video",
            "xbmc.addon.audio",
            "xbmc.addon.image",
            "xbmc.addon.executable",
            "xbmc.metadata.scraper.library",
            "xbmc.python.library",
            "xbmc.python.module",
            "kodi.game.controller"]

CONTENT_TYPES = ["xbmc.gui.skin","xbmc.subtitle.module","kodi.context.item", "kodi.resource.language","xbmc.addon.skin","kodi.resource.uisounds","xbmc.addon.audio","xbmc.addon.image","xbmc.addon.executable","xbmc.service","xbmc.python.library","xbmc.python.module","xbmc.python.script","xbmc.addon.video","xbmc.addon.repository"]
 
 

def set_Kodi_JSON(params):
    xbmc.executeJSONRPC('{"jsonrpc": "2.0", %s, "id": 1}' % params)
    
def set_Kodi_Enabled(plugin):
    set_Kodi_JSON('"method":"Addons.SetAddonEnabled","params":{"addonid":"%s","enabled":true}'%plugin)
        
def get_Kodi_JSON(params):
    return json.loads(unicode(xbmc.executeJSONRPC('{"jsonrpc": "2.0", %s, "id": 1}' % params), 'utf-8', errors='ignore'))
    
def get_Kodi_Disabled(type,content):
     return get_Kodi_JSON('"method":"Addons.GetAddons","params":{"type":"%s","content":"%s","enabled":false,"installed":true}'%(type,content))

def get_Kodi_Anabled():	 
    xbmc.executebuiltin('RunScript(special://home/addons/plugin.program.senyorwizard/skinAddon.py)')	 
	 
def aaa():
    percent       = 0
    count         = 0
    loop          = 0
    details       = []
    dlg           = xbmcgui.DialogProgress()
    dlg.create(ADDON_NAME)
    
    for content in CONTENTS:
        for type in CONTENT_TYPES:
            loop += 1
            if (dlg.iscanceled()):
                dlg.close()
                break
            percent = loop * 100 // len(CONTENT_TYPES)
            dlg.update(percent)
            details.append(get_Kodi_Disabled(type,content))
            
    for json_response in details:
        if json_response.has_key('result') and (json_response['result'] != None) and json_response['result'].has_key('addons'):
            count   = 0
            for item in json_response['result']['addons']:
                if (dlg.iscanceled()):
                    dlg.close()
                    break
                dlg.update((count * 100 // len(json_response['result']['addons'])),'Checking: %s'%item['type'],'Enabling: %s'%item['addonid'])
                set_Kodi_Enabled(item['addonid'])
                xbmc.sleep(100)
    dlg.update(100)
    dlg.close()


def exoduset():
    Config = xbmcaddon.Addon(id='plugin.video.exodus')
    Config.setSetting(id='provider.movieflixter', value='false')
    Config.setSetting(id='provider.moviegross', value='false')
    Config.setSetting(id='provider.watchhd', value='false')	
    Config.setSetting(id='provider.einthusan', value='false')
    Config.setSetting(id='provider.torba', value='false')
    Config.setSetting(id='provider.pubfilm', value='false')
    Config.setSetting(id='provider.xmovies', value='false')		


def spectoset():
    Config = xbmcaddon.Addon(id='plugin.video.specto')
    Config.setSetting(id='vidics', value='false')
    Config.setSetting(id='vidics_tv', value='false')
    Config.setSetting(id='xmovies', value='false')	
    Config.setSetting(id='pubfilm', value='false')
    Config.setSetting(id='pubfilm_tv', value='false')
    Config.setSetting(id='playback_captcha_hosts', value='false')	

def exinfoset():
    Config = xbmcaddon.Addon(id='script.extendedinfo')
    Config.setSetting(id='LanguageID', value='he')

def zenset():
    Config = xbmcaddon.Addon(id='plugin.video.zen')
    Config.setSetting(id='provider.moviegee', value='false')
    Config.setSetting(id='provider.vidics', value='false')
    Config.setSetting(id='provider.afdah', value='false')
    Config.setSetting(id='provider.xmovies', value='false')		
	
def userdataInstaller(id):
	global repo_addons
	if id in repo_addons:
		url = repo_addons[id]
		local_filename = url.split('/')[-1]
	else:
		print "*** {0}: ERROR: {1} don't exist in Repo".format(AddonName,id)
		return 0
	addonsfolder = xbmc.translatePath(os.path.join('special://','home'))
	if os.path.isdir(os.path.join(addonsfolder,id)):
		print "*** {0}: Exist {1} in Kodi".format(AddonName,id)
		return 0
	packfolder = xbmc.translatePath(os.path.join('special://','home','addons','packages'))
	dp = xbmcgui.DialogProgress(); 
	dp.create("Senyor Wizard"," מוריד "+id,'','נא להמתין')
	addon_zip = os.path.join(packfolder,local_filename)
	try: os.remove(addon_zip)
	except: pass
	print "*** {0}: Downloading {1}".format(AddonName,id)
	download_try=0
	while True:
		AddonDownload(url,addon_zip,dp)
		try:
			test_zip_file = zipfile.ZipFile(addon_zip)
			ret = test_zip_file.testzip()
			if ret is None:
				break
		except:pass
		download_try += 1
		xbmc.sleep(4000)
		if download_try>4:
			pass
			return 1
	time.sleep(2)
	print "*** {0}: Extracting {1}".format(AddonName,local_filename)
	dp.update(0,"Extracting Zip {0}".format(id),"",'פורס קבצים')
	AddonExtract(addon_zip,addonsfolder,dp)

def AddonInstaller(id):
	global repo_addons
	if id in repo_addons:
		url = repo_addons[id]
		local_filename = url.split('/')[-1]
	else:
		print "*** {0}: ERROR: {1} don't exist in Repo".format(AddonName,id)
		return 0
	addonsfolder = xbmc.translatePath(os.path.join('special://','home','addons'))
	if os.path.isdir(os.path.join(addonsfolder,id)):
		print "*** {0}: Exist {1} in Kodi".format(AddonName,id)
		return 0
	packfolder = xbmc.translatePath(os.path.join('special://','home','addons','packages'))
	dp = xbmcgui.DialogProgress(); 
	dp.create("Senyor Wizard"," מוריד "+id,'','נא להמתין')
	addon_zip = os.path.join(packfolder,local_filename)
	try: os.remove(addon_zip)
	except: pass
	print "*** {0}: Downloading {1}".format(AddonName,id)
	download_try=0
	while True:
		AddonDownload(url,addon_zip,dp)
		try:
			test_zip_file = zipfile.ZipFile(addon_zip)
			ret = test_zip_file.testzip()
			if ret is None:
				break
		except:pass
		download_try += 1
		xbmc.sleep(4000)
		if download_try>4:
			OKmsg("תקלה בהורדה",'לא ניתן להוריד את ההרחבה','לתמיכה חפשו אותנו בפייסבוק','Kodi Senyor')
			print "*** {0}: Error Downloading {1}".format(AddonName,id)
			return 1
	time.sleep(2)
	print "*** {0}: Extracting {1}".format(AddonName,local_filename)
	dp.update(0,"Extracting Zip {0}".format(id),"",'פורס קבצים')
	AddonExtract(addon_zip,addonsfolder,dp)
	try:
		depends = xbmc.translatePath(os.path.join(addonsfolder,id,'addon.xml')); 
		source = open(depends,mode='r'); line=source.read(); source.close();
		regex =ur'import addon="(.+?)"'
		addon_requires = re.findall(regex, line)
		for addon_require in addon_requires:
			if not 'xbmc.' in addon_require:
				dependspath = xbmc.translatePath(os.path.join('special://home/addons',addon_require))
				if not os.path.exists(dependspath): 
					AddonInstaller(addon_require)
	except:pass

def OKmsg(title, line1, line2="", line3=""):
	xbmcgui.Dialog().ok(title, line1, line2, line3)	


	
def AddonDownload(source, target,dp = None):
	if not dp:
		dp = xbmcgui.DialogProgress()
		dp.create("מצב...","בודק התקנה",' ', ' ')
	dp.update(0)
	r = requests.get(source, stream=True, timeout=10)
	try:
		total_size = r.headers['content-length'].strip()
		total_size = int(total_size)
	except:
		return
	bytes_so_far = 0

	with open(target, 'wb') as fp:
		try:
			for chunk in r.iter_content(chunk_size=(1024*8)):
				if chunk:
					bytes_so_far += len(chunk)
					percent = min((100*bytes_so_far/total_size), 100)
					dp.update(percent)

					fp.write(chunk)

					if dp.iscanceled():
						raise Exception("Canceled")
						fp.close();	r.close(); dp.close()
						return 0
		except:pass
	fp.close()
	r.close()
	return 1

def AddonExtract(_in, _out, dp):
    zin = zipfile.ZipFile(_in,  'r')
    nFiles = float(len(zin.infolist()))
    count  = 0

    try:
        for item in zin.infolist():
            count += 1
            update = count / nFiles * 100
            dp.update(int(update))
            zin.extract(item, _out)
    except Exception, e:
        print str(e)
        return False

    return True

def upd():
    xbmc.executebuiltin("XBMC.UpdateLocalAddons()")
	
def GetRepoInfo(repo):
	global repo_addons
	u1=urllib2.urlopen(repo+"addons.xml")
	dom=minidom.parse(u1)
	addons = dom.getElementsByTagName("addon")
	for addon in addons:
		id = addon.getAttribute("id")
		version = addon.getAttribute("version")
		repo_addons[id] = repo+id+"/"+id+"-"+version+".zip"

	return 1


def GetRepoInfob(repo):
	global repo_addons
	u1=urllib2.urlopen(repo+"addons.xml")
	dom=minidom.parse(u1)
	addons = dom.getElementsByTagName("addon")
	for addon in addons:
		id = addon.getAttribute("id")
		version = addon.getAttribute("version")
		repo_addons[id] = repo+"/repo/"+id+"/"+id+"-"+version+".zip"

	return 1

def GetRepoInfoc(repo):
	global repo_addons
	u1=urllib2.urlopen(repo+"addons.xml")
	dom=minidom.parse(u1)
	addons = dom.getElementsByTagName("addon")
	for addon in addons:
		id = addon.getAttribute("id")
		version = addon.getAttribute("version")
		repo_addons[id] = repo+"/Zips/"+id+"/"+id+"-"+version+".zip"

	return 1	
		
def GetRepoInfod(repo):
	global repo_addons
	u1=urllib2.urlopen(repo+"openeleq-addons.xml")
	dom=minidom.parse(u1)
	addons = dom.getElementsByTagName("addon")
	for addon in addons:
		id = addon.getAttribute("id")
		version = addon.getAttribute("version")
		repo_addons[id] = repo+"/zips/"+id+"/"+id+"-"+version+".zip"

	return 1			
		
		
global repo_addons, AddonName
Addon = xbmcaddon.Addon
AddonName = ("name")
repo_addons = {}

def fona():
    choice = xbmcgui.Dialog().yesno('[COLOR=green]Senyor Wizard[/COLOR]', '', 'האם להמשיך בתהליך ההתקנה?', nolabel='לא',yeslabel='כן')
    if choice == 0:
        sys.exit(1)
    elif choice == 1:
        pass
    
fona()

Config.setSetting(id='pvrset', value='0')
Config.setSetting(id='build', value='false')
Config.setSetting(id='addonsset', value='false')
Config.openSettings()


GetRepoInfoc("https://raw.githubusercontent.com/kobiko3030/repository.kodisenyor/master/")
GetRepoInfo("https://raw.githubusercontent.com/kobiko3030/kodi-senyor/master/wizardrepo/")
GetRepoInfo("http://mirror.onet.pl/pub/mirrors/kodi/addons/krypton/")


userdataInstaller("basic_userdata")

GetRepoInfob("https://raw.githubusercontent.com/kodil/kodil/master/")
#GetRepoInfo("http://repo.thewiz.info/")

if Config.getSetting("addonsset") == 'true':	
    if Config.getSetting("addonsset") == 'true':
       userdataInstaller("senyor.wall.krypton.data")


if Config.getSetting("build") == 'true':	
    if Config.getSetting("build") == 'true':
       userdataInstaller("pvr.userdata")

AddonInstaller("resource.language.he_il")	   
time.sleep(2)
get_Kodi_Anabled()
time.sleep(2)	   
xbmc.executebuiltin('RunScript(special://home/addons/plugin.program.senyorwizard/resources/img/fon_krypton_basic.py)')
time.sleep(2)	
AddonInstaller("repository.kodi-senyor")
AddonInstaller("repository.TheWiz")
AddonInstaller("repository.kodil")
AddonInstaller("repository.xbmc-israel")
AddonInstaller("repository.exodus")
AddonInstaller("repository.filmkodi.com")
AddonInstaller("repository.schismtvaddons")	
userdataInstaller("userdata.general")
AddonInstaller("script.exodus.artwork")
AddonInstaller("plugin.video.exodus")
AddonInstaller("script.specto.media")
AddonInstaller("plugin.video.specto")
AddonInstaller("plugin.video.zen")
AddonInstaller("script.module.metahandler")
AddonInstaller("script.module.urlresolver")
AddonInstaller("script.module.israeliveresolver")
AddonInstaller("plugin.video.israelive")
AddonInstaller("service.subtitles.thewiz")	
AddonInstaller("service.subtitles.subscenter")
AddonInstaller("service.subtitles.opensubtitles")
AddonInstaller("plugin.video.anarchitv")
AddonInstaller("plugin.video.Vodil")
addonsettings.basickryptonbuild()

	

if Config.getSetting("addonsset") == 'true':	
    if Config.getSetting("addonsset") == 'true':
       #GetRepoInfod("https://github.com/OpenELEQ/repository.q.krypton/raw/master/")	
       AddonInstaller("plugin.video.metalliq")       		          	   
       AddonInstaller("plugin.video.senyor.imdb.watchlists")
       AddonInstaller("plugin.video.phstreams")	   

  
	   
time.sleep(2)
xbmc.executebuiltin("XBMC.UpdateLocalAddons()")
time.sleep(3)
get_Kodi_Anabled()
time.sleep(10)
exoduset()
spectoset()
zenset()	 
time.sleep(5)
if Config.getSetting("build") == 'true':

    if Config.getSetting("build") == 'true':
        if Config.getSetting("pvrset") == '0':
            Progress.create("מתקין לקוח  טלוויזיה חיה", "נא להמתין...")
            Progress.update(30)
        if Config.getSetting("pvrset") == '1':
            AddonInstaller("pvr.openelec")
            Progress.create("מתקין לקוח  טלוויזיה חיה", "נא להמתין...")
            Progress.update(30)
        if Config.getSetting("pvrset") == '2':
            AddonInstaller("pvr.libraelec")
            Progress.create("מתקין לקוח  טלוויזיה חיה", "נא להמתין...")
            Progress.update(30)			
    else: pass

    if Config.getSetting("build") == 'true':
       addonsettings.lastset()
    else: pass	

dialog.ok('senyor wizard ','ההתקנה הסתיימה','','')	
	
time.sleep(10)
xbmc.executebuiltin('UpdateLibrary(video)') 



	



